<!doctype html>
<html lang="en">

<head>
	<meta charset="utf-8">

	<title>Gitlab CI/CD</title>

	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">
	<link rel="stylesheet" href="css/theme/league.css">


	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">
	<link rel="stylesheet" href="css/slide-theme.css">

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement( 'link' );
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName( 'head' )[0].appendChild( link );
	</script>

	<!--[if lt IE 9]>
	<script src="lib/js/html5shiv.js"></script>
	<![endif]-->

	<!-- Global site tag (gtag.js) - Google Analytics -->
	<script async src="https://www.googletagmanager.com/gtag/js?id=UA-160622945-1"></script>
	<script>
		window.dataLayer = window.dataLayer || [];
		function gtag(){dataLayer.push(arguments);}
		gtag('js', new Date());

		gtag('config', 'UA-160622945-1');
	</script>
</head>

<body>

<div class="reveal">

	<!-- Any section element inside of this container is displayed as a slide -->
	<div class="slides">


		<section data-transition="slide" data-background-transition="zoom">
			<h2>Automatize!</h2>
			<p>
				Libertando o potencial das pipelines CI/CD do Gitlab
			</p>


			<img src="images/logo-gitlab.png" width="300" class="no-border"/>

			<p style="text-align: right">
				Márcio Gurgel
			</p>
		</section>

		<section data-transition="slide" data-background-transition="zoom" >

			<h2>Códigos fonte</h2>

			<p>O código fonte desta apresentação está disponível em:</p>
			<p><a target="_blank" href="https://gitlab.com/marcio.rga/apresentacao-gitlabcicd">https://gitlab.com/marcio.rga/apresentacao-gitlabcicd</a></p>
			<br/>
			<p>O código fonte da aplicação está disponível em:</p>
			<p><a target="_blank" href="https://gitlab.com/marcio.rga/codar-rest">https://gitlab.com/marcio.rga/codar-rest</a></p>


		</section>



		<section data-transition="slide" data-background-transition="zoom" >


			<section>

				<h2>Quem sou?</h2>


				<p>Mochileiro Caviar</p>
				<p>Baixista</p>


			</section>

			<section>

				<p>Arquiteto de Software da Coopersystem trabalhando no <b>Banco do Brasil</b></p>

			</section>

			<section>
				"Javeiro" desde 2007
			</section>


			<section>
				<p>Bacharel em Sistemas de informação</p>
				<p>Pós graduado em Tecnologias Disruptivas (IESB)</p>
			</section>

			<section>

				<img src="images/bg_i_turn_coffee_into_code.jpg" height="450" />
			</section>

		</section>

		<section data-transition="slide" data-background="images/linus-torvalds-con.jpg" data-background-transition="zoom">

			<p class="fragment fade-up hljs">
				"Criei meu segundo grande projeto para armazenar meu primeiro grande projeto"
			</p>
			<p style="text-align: right">
				Linus Torvalds
			</p>


		</section>


		<section data-transition="slide" data-background="#4d7e65" data-background-transition="zoom">


			<section>
				<h2>Por que automatizar?</h2>
				<br/>


			</section>

			<section>
				<h2>Rotinas manuais são <b>passíveis de falhas</b></h2>
				<p class="fragment fade-up" style="font-style: italic">(Ainda mais quando estamos enjoados de fazer a mesma coisa)</p>
			</section>

			<section>
				<h3>Precisou fazer uma mesma coisa duas vezes? &nbsp; </h3>
				<img class="no-border" height="80" src="images/eye_emoji.png"/>
				<p class="fragment fade-up" style="font-style: italic">O benefício de ser programador é que nossa "receita de bolo" pode ser automatizada</p>
			</section>


			<section data-background-transition="zoom"  data-background="#4d7e65">

					<span>Deixe o computador trabalhar por você</span><br/>
					<span>Guarde seu foco para o que <b>realmente</b> interessa</span>
					<br/>
					<img src="images/codar_robot_working.jpeg" height="300" />

			</section>


		</section>


		<section data-transition="slide" data-background-transition="zoom">

			<section>
				<h2>Por que o Gitlab?</h2>
			</section>


			<section>
				Utilização gratuíta em gitlab.com
			</section>

			<section>Possibilidade de instalação <b>"on premise"</b></section>
			<section>Versão community é suficientemente completa</section>
			<section><b>All-in-one:</b><br/><br/> board,<br/> Wiki,<br/> bug tracking,<br/> editores,<br/> <span style="font-size: 60px;font-weight: bold"> >>> CI/CD <<< </span></section>


		</section>




		<section data-transition="slide" data-background-transition="zoom" data-background="#4d7e65">

			<h2>Código no centro das atenções</h2>

			<p class="fragment fade-up"><img src="images/codar_code_at_center.png" class="no-border" height="440"/></p>


			<p style="width: 40%; float: top;	  box-shadow: 0 1px 4px rgba(0,0,0,0.5), 0 5px 25px rgba(0,0,0,0.2); background-color: rgba(0, 0, 0, 0.9); color: #fff; padding: 20px; font-size: 30px; text-align: left;">
				Eventos disparados por mudanças no código
			</p>

		</section>






		<section data-transition="slide" data-background-transition="zoom" data-background="#F3F3F3">

			<section>

				<h2 style="background-color: #4d7e65;">"CI/CD ++" em uma pipeline</h2>

				<p class="fragment fade-up"><img src="images/codar_more_than_ci_cd.png" class="no-border" height="500"/></p>


			</section>


		</section>


		<section data-transition="slide" data-background-transition="zoom" >

			<section>
				<h2 style="background-color: #4d7e65;">Os ingredientes básicos para fazer isso funcionar são:</h2>
			</section>


			<section data-background="#4d7e65">
				<img src="images/tux.png" height="320" class="no-border"/>
				<p><b>Servidor acessível pelo GitLab</b></p>
				<p><i style="font-style: italic">(existem opções free hospedadas no google)</i></p>

			</section>

			<section >
				<img src="images/agent_runner.png" height="468"/>
				<p>Faz a intermediação da criação dos runners</p>

			</section>

			<section data-background="#4d7e65">
				<img src="images/runner.png" height="251" class="no-border"/>
				<p>É o elo entre Gitlab e o seu servidor</p>
				<p>Pode-se cadastrar "N" runners em um mesmo servidor</p>

			</section>


		</section>



		<section data-transition="slide" data-background-transition="zoom" data-background="#FBF8E8">

			<section>

				<h2 style="background-color: #4d7e65;">Gitlab <b>runners</b></h2>

				<p class="fragment fade-up"><img src="images/codar_different-environments.png" class="no-border" height="460"/></p>


			</section>



		</section>


		<section  data-background="#4D7E65">

			<h2 style="background-color: #B5533C;">O surgimento da pipeline</h2>
			<p class="fragment fade-up"><img src="images/codar_push_effect.png" class="no-border" height="550"/></p>


		</section>


		<section data-background="images/almighty.jpg">

			<h2 style="background-color: #B5533C;">JOBs executam comandos nativos</h2>

				<code class="hljs" data-trim data-line-numbers="1" style="font-size: 60px">#!/bin/sh</code>

		</section>


		<section data-transition="slide" data-background-transition="zoom">

			<h2 style="background-color: #4D7E65">Mãos à obra</h2>

			<p><b>Temos um projeto com as seguintes características</b></p>
			<p>
				<ul>
					<li>Java</li>
					<li>Spring boot (container embarcado)</li>
					<li>Interface REST disposta em (https://legrug.dev/greeting)</li>
					<li>Testes com Junit</li>
				</ul>
			</p>

			<p class="fragment fade-up hljs">Vamos criar uma pipeline de CI/CD</p>



		</section>


		<section data-transition="slide" data-background-transition="zoom">

			<h2>Registro dos runners</h2>

			<p style="font-style: italic"><i>(Nosso servidor já tem o agente runner instalado)</i></p>
			<p>Runner docker:</p>

<pre>
<code class="hljs" data-trim data-line-numbers="1" >
sudo gitlab-runner register \
  --non-interactive \
  --url "https://gitlab.com/" \
  --registration-token "PROJECT_REGISTRATION_TOKEN" \
  --executor "docker" \
  --docker-image alpine:latest \
  --description "Docker runner - Java APP" \
  --tag-list "codar-docker-runner"

</code>
</pre>


		</section>



		<section data-transition="slide" data-background-transition="zoom">

			<h2>Prazer, .gitlab-ci.yml</h2>

			<p style="font-style: italic">Aqui temos um estágio e um JOB</p>

			<pre>
<code class="hljs" data-trim data-line-numbers="1,7,13" >
stages:
  - compile

cache:
  paths:
    - .m2/

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2"


compile_jdk8:
  stage: compile
  image: maven:3.6.3-jdk-8
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean compile
</code>
</pre>
		</section>


		<section data-transition="slide" data-background-transition="zoom">

			<h2>O projeto vai migrar para Java 11 em breve...</h2>


			<pre>
<code class="hljs" data-trim data-line-numbers="2,3" >
compile_jdk11:
  stage: compile
  image: maven:3.6.3-jdk-11
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean compile
</code>
</pre>
		</section>



		<section data-transition="slide" data-background-transition="zoom">

			<h2>Legal, mas e os testes?</h2>


			<pre>
<code class="hljs" data-trim data-line-numbers="3,5" >
stages:
  - compile
  - test

unit_test:
  stage: test
  image: maven:3.6.3-jdk-8
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean package


</code>
</pre>
		</section>


		<section data-transition="slide" data-background-transition="zoom">

			<h2>Agora que testa, vamos à cobertura</h2>

			<p>Vamos criar a variável "MIN_COVERAGE" para registrar o nível mínimo de cobertura</p>

			<pre>
<code class="hljs" data-trim data-line-numbers="4,18" >
stages:
  - compile
  - test
  - quality

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2"
  MIN_COVERAGE: ${MIN_COVERAGE}
  COVERAGE: 0


quality:
  stage: quality
  image: maven:3.6.3-jdk-8
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean package
    - COVERAGE_TMP=$(awk -F"," '{ instructions += $4 + $5; covered += $5 } END {  print 100*covered/instructions  }' target/site/jacoco/jacoco.csv)
    - COVERAGE=${COVERAGE_TMP%.*}
    - echo "$COVERAGE % covered"
  coverage: '/(\d+) % covered/'


</code>
</pre>
		</section>



		<section data-background-transition="zoom" data-transition="slide">

			<h2>Finalmente, o deploy</h2>
			<p>Vamos criar um runner diferente do tipo "shell" para ele</p>


<pre>
<code class="hljs" data-line-numbers="5" data-trim >
sudo gitlab-runner register \
	--non-interactive \
	--url "https://gitlab.com/" \
	--registration-token "PROJECT_REGISTRATION_TOKEN" \
	--executor "shell" \
	--description "Shell - Java APP" \
	--tag-list "codar-shell-runner"

</code>
</pre>
		</section>


		<section data-background-transition="zoom" data-transition="slide">

			<h2>Job de deploy</h2>


			<pre>
<code class="hljs" data-line-numbers="5" data-trim >
stages:
  - compile
  - test
  - quality
  - deploy


deploy_in_qa:
  stage: deploy
  tags:
    - codar-shell-runner
  environment:
    name: qa
    url: http://legrug.dev/greeting/
  only:
    - master
  when: manual
  script:
    - mvn clean package -Dmaven.test.skip=true
    - kill -9 $(ps -ef | grep gs-rest-service | awk '{print $2}') || true
    - echo "Processo anterior parado (na marra)"
    - cp target/gs-rest-service-0.1.0.jar /home/gitlab-runner/
    - java -jar /home/gitlab-runner/gs-rest-service-0.1.0.jar &>/home/gitlab-runner/app.log &
    - echo "Deploy finalizado"

</code>
</pre>
		</section>



		<section data-background-transition="zoom" data-transition="slide">

			<h2>Resultado final do arquivo .gitlab-ci.yml</h2>


			<pre>
<code class="hljs" data-line-numbers="5" data-trim >
stages:
  - compile
  - test
  - quality
  - deploy


cache:
  paths:
    - .m2/

variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2"


compile_jdk8:
  stage: compile
  image: maven:3.6.3-jdk-8
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean compile


compile_jdk11:
  stage: compile
  image: maven:3.6.3-jdk-11
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean compile


unit_test:
  stage: test
  image: maven:3.6.3-jdk-8
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean package


quality:
  stage: quality
  image: maven:3.6.3-jdk-8
  tags:
    - codar-docker-runner
  only:
    - branches
  script:
    - mvn clean package
    - COVERAGE_TMP=$(awk -F"," '{ instructions += $4 + $5; covered += $5 } END {  print 100*covered/instructions  }' target/site/jacoco/jacoco.csv)
    - COVERAGE=${COVERAGE_TMP%.*}
    - echo "$COVERAGE % covered"
  coverage: '/(\d+) % covered/'


deploy_in_qa:
  stage: deploy
  tags:
    - codar-shell-runner
  environment:
    name: qa
    url: http://legrug.dev/greeting/
  only:
    - master
  when: manual
  script:
    - mvn clean package -Dmaven.test.skip=true
    - kill -9 $(ps -ef | grep gs-rest-service | awk '{print $2}') || true
    - echo "Processo anterior parado (na marra)"
    - cp target/gs-rest-service-0.1.0.jar /home/gitlab-runner/
    - java -jar /home/gitlab-runner/gs-rest-service-0.1.0.jar &>/home/gitlab-runner/app.log &
    - echo "Deploy finalizado"


</code>
</pre>
		</section>







		<section data-background="images/thank-you.gif">

			<h2>
				MUITO OBRIGADO!
			</h2>

			<p class="fragment fade-up" style="background-color: #000000">
				<b>Instagram:</b> @marcio.rga @mochileiroscaviar<br/>
				<b>E-mail:</b> marcio.rga@gmail.com<br>
				<b>Linked-in:</b> <br/>

				<img src="images/qrcode.54361524.png" height="200" width="200"/><br/>
				Márcio Gurgel
			</p>

		</section>












	</div>

</div>

<script src="js/reveal.js"></script>

<script>

	// More info https://github.com/hakimel/reveal.js#configuration
	Reveal.initialize({
		controls: true,
		progress: true,
		center: true,
		hash: true,

		transition: 'slide', // none/fade/slide/convex/concave/zoom

		// More info https://github.com/hakimel/reveal.js#dependencies
		dependencies: [
			{ src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
			{ src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
			{ src: 'plugin/highlight/highlight.js', async: true },
			{ src: 'plugin/search/search.js', async: true },
			{ src: 'plugin/zoom-js/zoom.js', async: true },
			{ src: 'plugin/notes/notes.js', async: true }
		]
	});

</script>

</body>
</html>
